<template>
  <div
    class="min-h-full flex items-center justify-center py-6 px-4 sm:px-6 lg:px-8"
  >
    <div
      class="max-w-lg w-full space-y-2 bg-white p-4 md:px-8 md:py-10 shadow-xl z-index-10"
    >
      <div>
        <div class="flex justify-center text-indigo-700">
          <font-awesome-icon icon="dungeon" size="5x" />
        </div>
        <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
          S'inscrire
        </h2>
      </div>
      <form class="mt-8 space-y-6" method="POST" @submit="register">
        <div class="rounded-md shadow-sm -space-y-px">
          <TextField
            label="Pseudo"
            id="username"
            name="username"
            type="text"
            :value="values.lastname"
            @input="values[$event.target.name] = $event.target.value"
            required
            placeholder="Pseudo"
            class="pt-4"
          />
          <TextField
            label="Email"
            id="email"
            name="email"
            type="email"
            :value="values.email"
            @input="values[$event.target.name] = $event.target.value"
            required
            placeholder="exemple@domaine.fr"
            class="pt-4"
          />
          <TextField
            label="Mot de passe"
            id="password"
            name="plainPassword"
            type="password"
            :value="values.plainPassword"
            @input="values[$event.target.name] = $event.target.value"
            required
            placeholder="Mot de passe"
            class="pt-8"
          />
        </div>

        <div>
          <Button type="submit" icon="lock" label="S'inscrire" />
        </div>
        <span class="pt-8"
          >Votre mot de passe doit comporter au minimun 10 caractères(dont au
          moins une majuscule, une miniscule, un chiffre et un caractère
          spécial)</span
        >
      </form>
    </div>
  </div>
</template>

<script>
import TextField from "./Form/Field/TextField"
import Button from "./Form/ButtonForm"

export default {
  name: "Register",
  components: {
    TextField,
    Button
  },
  data: () => ({
    registerUrl: `https://${window.location.hostname}:8443/users`,
    values: {
      username: "",
      email: "",
      plainPassword: ""
    }
  }),
  inject: ["createAlert"],
  methods: {
    register: function(e) {
      e.preventDefault()
      fetch(this.registerUrl, {
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json"
        },
        method: "POST",
        body: JSON.stringify(this.values)
      })
        .then(async (res) => {
          if (res.ok) {
            this.createAlert({
              color: "green",
              text: "Inscription réussi",
              icon: "check"
            })

            setTimeout(() => {
              this.$router.push("/")
            }, 2000)
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped></style>
